var helix_web_services_client = require('../../index.js');

function createClient() {
  return new helix_web_services_client.ApiClient('http://localhost:9000');
}

function clientAsJdoe(callback) {
  var client = createClient();
  var api = client.createDefaultApi();

  var loginRequest = new helix_web_services_client.models.LoginRequest({
    user: 'jdoe',
    password: 'johndoe1A!'
  });
  api.loginPost(loginRequest, function (err, loginResponse) {
    if (err) {
      callback(err);
      return;
    }
    client.apiKey = loginResponse.ticket;
    callback(null, client);
  });
}


function clientAsSuper(callback) {
  var client = createClient();
  var api = client.createDefaultApi();

  var loginRequest = new helix_web_services_client.models.LoginRequest({
    user: 'super',
    password: 'superuser1A!'
  });
  api.loginPost(loginRequest, function (err, loginResponse) {
    if (err) {
      callback(err);
      return;
    }
    client.apiKey = loginResponse.ticket;
    callback(null, client);
  });
}

module.exports = {
  clientAsJdoe: clientAsJdoe,
  clientAsSuper: clientAsSuper,
  createClient: createClient
};